#!/usr/bin/perl

use strict;
#use warnings;
use Glib qw/TRUE FALSE/;
use Gtk2;
use Gtk2::TrayIcon;
use Gtk2::Helper;
use vars qw/$list/;

#singal catch
$SIG{INT} = sub {&prequit;print "got SIGINT,quit!\n";exit};
$SIG{QUIT} = sub {&prequit;print "got SIGQUIT,quit!\n";exit};
$SIG{HUP} = sub {&prequit;print "got SIGHUP,quit!\n";exit};
$SIG{TRAP} = sub {&prequit;print "got SIGTRAP,quit!\n";exit};
$SIG{KILL} = sub {&prequit;print "got SIGKILL,quit!\n";exit};
$SIG{TERM} = sub {&prequit;print "got SIGTERM,quit!\n";exit};

#Environment setup

 #resolve the path issue when using sudo
	$ENV{PATH} = "$ENV{PATH}:/usr/sbin:/sbin";

 #X11 issue (I hope this fix can work on both GDM and SLiM)
        chomp(my $auth = `pgrep -f -l :0.Xauth`); $auth =~ m/-auth\s(.*?)\s.*/;
	$ENV{XAUTHORITY} = $1;

 #proxy (for &SendScout)
	chomp(my $proxy = `cat /etc/netpkg.conf|grep ^Proxy_Socket`);
	$proxy =~ m/Proxy_Socket\s*=\s*(http:\/\/)(.*)/;
	$proxy = $2;
	$ENV{http_proxy} = "http://$proxy" if ($proxy);

 #last accessed ZW repo
 	chomp(my $repo = `cat /var/netpkg/db/last_mirror`);

# use HEAD script from lwp to check "Last-modified" tags of remote file (CHECKSUMS.md5.gz)
sub SendScout {
	Gtk2->main_iteration while ( Gtk2->events_pending );
	my $mode = shift;
	my $state;
	if ($mode eq 'init') {
		Gtk2->main_iteration while ( Gtk2->events_pending );
		system("GET $repo/CHECKSUMS.md5.gz 1> /tmp/CHECKSUMS.md5.gz") || return "ok"; # use && not || for system  
		Gtk2->main_iteration while ( Gtk2->events_pending );
	}else{
		Gtk2->main_iteration while ( Gtk2->events_pending );
		system("GET -i /tmp/CHECKSUMS.md5.gz $repo/CHECKSUMS.md5.gz 1> /tmp/CHECKSUMS.md5.gz") or ($state = 1);
		Gtk2->main_iteration while ( Gtk2->events_pending );
	}
	Gtk2->main_iteration while ( Gtk2->events_pending );

# determine what to do according to $state	
	if ($state) {
		&init;
	}else{
		&listing; # call &listing again to reschedule &keepchk
	}
	
return FALSE;
}

#prevent duplicate process
chomp(my $pid = `pgrep -o -u root -f autoUpdate.pl\$`);
if (int($pid) && $pid ne $$) {
	print "I am $$, process $pid already running, quit!!!\n";
	exit;
}else{
	&prequit; #clean up the old auto_black.tmp 
};	


#preparation before quitting
sub prequit {
	unlink "/tmp/auto_black.tmp";
}



my @black;#black_list
$black[0] = '^[a-zA-Z]';
$black[1] = '^$';

#creating black_list
chomp(my $tmp = `cat /etc/netpkg.conf|grep -m1 ^Black_list`);
$tmp =~ m/.*=\s*(.*)/;
push @black, split(/\s+/, $1);
system("echo $_ >> /tmp/auto_black.tmp") foreach @black;

my $list;
my $network;
my $def_time = 99;#seconds

Gtk2->init;

#The main icon that matches the system menu! ;)
my $icon_main = Gtk2::Gdk::Pixbuf->new_from_file_at_size("/usr/share/icons/hicolor/scalable/apps/face-glasses.svg",24,24);


#icon goes in box, box goes in tray
my $icon = Gtk2::Image->new_from_pixbuf($icon_main);

my $eventbox = Gtk2::EventBox->new;
$eventbox->add($icon);


#$eventbox->set_size_request(24,24);
my $tray = Gtk2::TrayIcon->new('Test');
$tray->add($eventbox);

#events and timeouts
$eventbox->signal_connect('button_release_event', \&click);


#tooltip
my $tooltip = Gtk2::Tooltips->new;
$tooltip->set_tip($tray,'ZUT v0.7.7');







# initialize
sub init {
	#first check the network
	$network = `host www.zenwalk.org > /dev/null && echo 1`;


	#start checking
	if ($network) {

		$icon->set_from_pixbuf($icon_main);
		$tooltip->set_tip($tray,"Checking for updates... ");
		Gtk2->main_iteration while ( Gtk2->events_pending );
		open my $npkg,"nice -19 netpkg list U|grep --mmap -c -v -f /tmp/auto_black.tmp|" or die "What!!!$!\n";
		
		my $tag;
		$tag = Gtk2::Helper->add_watch(fileno($npkg),in => sub {
		while(<$npkg>){
			chomp($list .= $_);
			print "|$list|";
			last if (eof($npkg));
		}
		close($npkg);
                Gtk2::Helper->remove_watch($tag);
		Gtk2->main_iteration while ( Gtk2->events_pending );

		&listing;
		return 1;
		} );
		#print "\n *** DEBUG: got list = $list***";

	}else{

		Gtk2->main_iteration while ( Gtk2->events_pending );
		my $icon_nonet = Gtk2::Gdk::Pixbuf->new_from_file_at_size("/usr/share/icons/hicolor/scalable/apps/face-devil-grin.svg",24,24);
	    	$icon->set_from_pixbuf($icon_nonet);
		$tooltip->set_tip($tray,"Network Issue! Left click when ready!");
		Gtk2->main_iteration while ( Gtk2->events_pending );

	}
	return FALSE;
}

#setup a timer for another recheck (init);
sub keepchk {
	#print "\n *** DEBUG-keepchk: list = $list***";
	my $time = shift; #in milliseconds
	Glib::Timeout->add($time,\&SendScout);

	return 1;
};


sub listing {
		Gtk2->main_iteration while ( Gtk2->events_pending );
		$repo =~ m/[hHtTfF]+tp:\/\/+([^\/]+)\/*.*\/+(.*)$/;
		#$repo =~ m/http:\/\/(.*?)\/()$/;
		my $r_info = "$1\nType: $2";

		#chomp($list);

		if (int($list)) {
			my $icon_bad = Gtk2::Gdk::Pixbuf->new_from_file_at_size("/usr/share/icons/hicolor/scalable/apps/face-surprise.svg",24,24);
			$icon->set_from_pixbuf($icon_bad);
			my $line = "There are $list package updates";
			$line =~ s/are\s+1\s+package\s+updates/is 1 package update/g;
			$tooltip->set_tip($tray,"$line\nRepo: $r_info");
			&keepchk(1200000);
			#print "\n *** DEBUG: list = $list\n\n";
		}else{
			my $icon_good = Gtk2::Gdk::Pixbuf->new_from_file_at_size("/usr/share/icons/hicolor/scalable/apps/face-grin.svg",24,24);
			$icon->set_from_pixbuf($icon_good);
			$tooltip->set_tip($tray,"Your system is up to date!\nRepo: $r_info");
			&keepchk(3600000);

		}


	return 1;
}

#handles tray clicks
sub click {
Gtk2->main_iteration while ( Gtk2->events_pending );
    #left mouse button
    if ($_[1]->button == 1) {
	    $icon->set_from_pixbuf($icon_main);
	    &prequit;
	    #print "\n *** DEBUG: int\(list\) = ",int($list),", list = $list\n\n";
	    exec("DISPLAY=:0.0 xnetpkg && sleep 10 && DISPLAY=:0.0 /usr/sbin/autoUpdate.pl &") if (int($list));
	    exec("sleep $def_time && DISPLAY=:0.0 /usr/sbin/autoUpdate.pl &");
    }
   
    #right mouse button
    elsif ($_[1]->button == 3) {
	    &menu;
    }
    return 1;
}


#right click menu
sub menu {
Gtk2->main_iteration while ( Gtk2->events_pending );
    my $menu = Gtk2::Menu->new();

    #Quit
    my $menu_quit = Gtk2::ImageMenuItem->new_with_label("Quit");
    $menu_quit->set_image(Gtk2::Image->new_from_stock('gtk-quit', 'menu'));
    $menu->add($menu_quit);
    Gtk2->main_iteration while ( Gtk2->events_pending );

    $menu_quit->signal_connect('button_release_event',\&click_pop);
    Gtk2->main_iteration while ( Gtk2->events_pending );

    #subroutine for menu_quit
    sub click_pop {

    	    if ($_[1]->button == 1) {
		    &prequit;
		    $menu->popdown;
    		    $tray->remove($eventbox);
    		    $eventbox->remove($icon);

    	    }
    		Gtk2->main_iteration while ( Gtk2->events_pending );
		Gtk2->main_quit;
	    #exit;
	    system("pstr --level=3 autoUpdate.pl|xargs -l kill -9 2>/dev/null");
    };
    

    $menu->show_all;

    #popup menu, the three is for right mouse button
    $menu->popup(undef,undef,undef,3,undef,undef);

    return 1;
}


my $tests = &SendScout('init');
#show tray
$tray->show_all;
Gtk2->main_iteration while ( Gtk2->events_pending );
#print $tests,"\n";
&init;



Gtk2->main;
